package com.gct.warning.controller;

import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.gct.common.core.result.Result;
import com.gct.warning.service.impl.MainServiceImpl;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import io.swagger.annotations.ApiParam;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

/**
 * @author xusirui 2021/5/7
 */
//@CrossOrigin
@RestController
@RequestMapping("/warning")
public class MainController {

    @Autowired
    MainServiceImpl mainService;

    @ApiOperation("获取问题列表内容")
    @PostMapping("/getProblemListItems")
    public Result getProblemListItems(@ApiParam("isdeal " + "category " + "rank " + "level " + "item " + "beginDate " + "endDate")
                                      @RequestBody JSONObject jsonObject) {
        Boolean isdeal = jsonObject.getBoolean("isdeal");
        String category = jsonObject.getString("category");
        String rank = jsonObject.getString("rank");
        Integer level = jsonObject.getInteger("level");
        String item = jsonObject.getString("item");
        String beginDate = jsonObject.getString("beginDate");
        String endDate = jsonObject.getString("endDate");
        return mainService.getProblemListItems(isdeal, category, JSONArray.parseArray(rank, String.class), level, item, beginDate, endDate);
    }

    @PostMapping("/getMsgCount")
    public Result getMsgCount(@RequestBody JSONObject jsonObject) {
        String date = jsonObject.getString("date");
        String rank = jsonObject.getString("rank");
        Integer orgId = jsonObject.getInteger("orgId");
        Integer level = jsonObject.getInteger("level");
        Integer curPage = jsonObject.getInteger("curPage");
        Integer pageSize = jsonObject.getInteger("pageSize");
        return mainService.getMsgCount(date, JSONArray.parseArray(rank, String.class), level, orgId);
    }

    @PostMapping("/getAllGKWarning")
    public Result getAllGKWarning(@RequestBody JSONObject jsonObject) {
        String date = jsonObject.getString("date");
        String rank = jsonObject.getString("rank");
        Integer orgId = jsonObject.getInteger("orgId");
        Integer level = jsonObject.getInteger("level");
        Integer curPage = jsonObject.getInteger("curPage");
        Integer pageSize = jsonObject.getInteger("pageSize");
        return mainService.getAllGKWarning(date, JSONArray.parseArray(rank, String.class), level, orgId, curPage, pageSize);
    }

    @PostMapping("/getNotConfirmGKWarning")
    public Result getNotConfirmGKWarning(@RequestBody JSONObject jsonObject) {
        String date = jsonObject.getString("date");
        String rank = jsonObject.getString("rank");
        Integer orgId = jsonObject.getInteger("orgId");
        Integer level = jsonObject.getInteger("level");
        Integer curPage = jsonObject.getInteger("curPage");
        Integer pageSize = jsonObject.getInteger("pageSize");
        return mainService.getNotConfirmGKWarning(date, JSONArray.parseArray(rank, String.class), level, orgId, curPage, pageSize);

    }

    @GetMapping("/getStatisticalAnalysis")
    public Result getStatisticalAnalysis(@ApiParam("开始时间") @RequestParam String beginDate,
                                         @ApiParam("结束时间") @RequestParam String endDate,
                                         @ApiParam("当前层级深度") @RequestParam Integer level,
                                         @ApiParam("当前页面父ID") @RequestParam Integer orgId
                                         ) {
        return mainService.getStatisticalAnalysis(beginDate, endDate, level,orgId);
    }
}
