package com.gct.warning.feignclient;


import com.alibaba.fastjson.JSONArray;
import com.gct.common.core.result.Result;
import io.swagger.annotations.ApiParam;
import org.springframework.cloud.openfeign.FeignClient;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;

/**
 * @author xusirui 2021/5/6
 */
@FeignClient(value = "centralbase", fallback = BaseDataHystrix.class/*, url = "${feign.addr}"*/)
public interface BaseDataClient {

    @RequestMapping(value = "/cbPcProWellboreVolDaily/getCbPcProWellBoreVolDaily/{prodDate}/{curPage}/{pageSize}")
    String getCbPcProWellBoreVolDaily(@PathVariable("prodDate") String prodDate, @PathVariable("curPage")
            Integer curPage, @PathVariable("pageSize") Integer pageSize);

    @RequestMapping("/org/getOrgById/{id}")
    String getOrgById(@PathVariable("id") String id);


    @RequestMapping("/cbCdWellSource/getWellInfo/{curPage}/{pageSize}")
    String getWellInfo(@PathVariable("curPage") Integer curPage, @PathVariable("pageSize") Integer pageSize);

    @GetMapping("/WellSource/jh")
    String getJh(@RequestParam(value = "orgid", required = false) String orgid);


}
