package com.gct.warning.service.impl;

import com.alibaba.fastjson.JSONObject;
import com.gct.warning.entity.WnGkMsg;
import com.gct.warning.service.ReciveWnGkMsgService;
import com.gct.warning.service.WnGkMsgService;
import lombok.extern.slf4j.Slf4j;
import org.apache.rocketmq.spring.annotation.ConsumeMode;
import org.apache.rocketmq.spring.annotation.RocketMQMessageListener;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

/**
 * @author xusirui 2021/5/13
 */
@Slf4j
@Service
@RocketMQMessageListener(
        nameServer = "${rocketmq.nameserver}",
        topic = "${rocketmq.topic}",
        consumerGroup = "${rocketmq.producer.group}",
        consumeMode = ConsumeMode.ORDERLY //保证同一队列顺序消费
)
public class ReciveWnGkMsgServiceImpl implements ReciveWnGkMsgService {

    @Autowired
    WnGkMsgService wnGkMsgService;

    @Override
    public void onMessage(String s) {

        WnGkMsg wnGkMsg = JSONObject.parseObject(s, WnGkMsg.class);
        wnGkMsgService.addWnGkMsg(wnGkMsg);
    }
}
