package com.gct.warning.service.impl;

import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.gct.common.core.result.Result;
import com.gct.warning.entity.WnWellInfo;
import com.gct.warning.entity.WnWellStatus;
import com.gct.warning.feignclient.BaseDataClient;
import com.gct.warning.service.WnWellInfoService;
import com.gct.warning.service.WnWellStatusService;
import org.springframework.beans.factory.annotation.Autowired;

import java.time.LocalDate;
import java.time.LocalDateTime;
import java.time.format.DateTimeFormatter;
import java.util.*;
import java.util.concurrent.ScheduledThreadPoolExecutor;
import java.util.concurrent.TimeUnit;

/**
 * @author xusirui 2021/5/6
 */

public class WarningTaskServiceImpl {

    @Autowired
    BaseDataClient baseDataClient;

    @Autowired
    WnWellStatusService wnWellStatusService;

    @Autowired
    WnWellInfoService wnWellInfoService;

    public void doService() {
        // ScheduledThreadPoolExecutor threadPool = new ScheduledThreadPoolExecutor(2);

        //threadPool.scheduleAtFixedRate(this::task, 0, 1, TimeUnit.HOURS);
    }

    public void task2() {
        List<WnWellStatus> list = new ArrayList<>();
        int curPage = 1;
        final int pageSize = 1000;
        int count;
        do {
            String s = baseDataClient.getCbPcProWellBoreVolDaily("2021-06-23", curPage++, pageSize);
            Result res = JSONObject.parseObject(s, Result.class);
            JSONArray jsonArray = JSONObject.parseArray(res.getData().toString());
            count = jsonArray.size();

        } while (count == pageSize);
        wnWellStatusService.saveAndUpdate(list);

        List<WnWellInfo> wnWellInfoList = new ArrayList<>();
        curPage = 1;
        do {
            String s = baseDataClient.getWellInfo(curPage++, pageSize);
            Result res = JSONObject.parseObject(s, Result.class);
            JSONArray jsonArray = JSONObject.parseArray(res.getData().toString());
            count = jsonArray.size();
            for (int i = 0; i < jsonArray.size(); i++) {
                JSONObject jo = jsonArray.getJSONObject(i);
                System.out.println(jo.toJSONString());
                WnWellInfo wellInfo = new WnWellInfo();
                if (jo.getString("spud_date")==null)continue;
                wellInfo.setWellId(jo.getString("well_id"))
                        .setWellName(jo.getString("well_common_name"))
                        .setOrgId(jo.getInteger("level3"))
                        .setLevel3(jo.getInteger("level3"))
                        .setLevel2(jo.getInteger("level2"))
                        .setLevel1(jo.getInteger("level1"))
                        .setLevelName3(jo.getString("level_name3"))
                        .setLevelName2(jo.getString("level_name2"))
                        .setLevelName1(jo.getString("level_name1"))
                        .setSpudDate(LocalDateTime.parse(jo.getString("spud_date"),DateTimeFormatter.ISO_DATE_TIME));
                wnWellInfoList.add(wellInfo);
            }
        } while (count == pageSize);
        wnWellInfoService.saveOrUpdateBatch(wnWellInfoList);
    }

    public void task() {
        List<WnWellStatus> list = new ArrayList<>();
        int curPage = 1;
        final int pageSize = 1000;
        int count;
        do {
            String s = baseDataClient.getCbPcProWellBoreVolDaily("2021-06-23", curPage++, pageSize);
            Result res = JSONObject.parseObject(s, Result.class);
            JSONArray jsonArray = JSONObject.parseArray(res.getData().toString());
            count = jsonArray.size();
            for (int i = 0; i < jsonArray.size(); i++) {
                WnWellStatus wnWellStatus = new WnWellStatus();
                JSONObject jao = jsonArray.getJSONObject(i);
                wnWellStatus.setProdDate(LocalDate.parse(jao.getString("prodDate")).atTime(0, 0, 0));
                wnWellStatus.setWellId(jao.getString("wellId"));
                wnWellStatus.setProdTime(jao.getDouble("prodTime"));
                wnWellStatus.setOrgId(jao.getInteger("orgId"));
                // todo 记录每口井当前已经处理到哪一天了
                Integer id = wnWellStatus.getOrgId();
                Stack<Integer> parIdSta = new Stack<>();
                Stack<String> parNameSta = new Stack<>();
                Integer level = -1;
                do {
                    parIdSta.push(id);
                    String org = baseDataClient.getOrgById(id.toString());
                    res = JSONObject.parseObject(org, Result.class);
                    JSONObject jo = JSONObject.parseObject(res.getData().toString());
                    id = Integer.parseInt(jo.getString("parentId"));
                    level = jo.getInteger("orgLevel");
                    parNameSta.push(jo.getString("orgName"));
                } while (level != 1);
                //一般最多只有五级，如果需要增加则增加数据库字段数量
                if (!parIdSta.isEmpty()) {
                    wnWellStatus.setLevel1(parIdSta.pop());
                    wnWellStatus.setLevelName1(parNameSta.pop());
                }
                if (!parIdSta.isEmpty()) {
                    wnWellStatus.setLevel2(parIdSta.pop());
                    wnWellStatus.setLevelName2(parNameSta.pop());
                }
                if (!parIdSta.isEmpty()) {
                    wnWellStatus.setLevel3(parIdSta.pop());
                    wnWellStatus.setLevelName3(parNameSta.pop());
                }
                if (!parIdSta.isEmpty()) {
                    wnWellStatus.setLevel4(parIdSta.pop());
                    wnWellStatus.setLevelName4(parNameSta.pop());
                }
                if (!parIdSta.isEmpty()) {
                    wnWellStatus.setLevel5(parIdSta.pop());
                    wnWellStatus.setLevelName5(parNameSta.pop());
                }
                if (!parIdSta.isEmpty()) {
                    wnWellStatus.setLevel6(parIdSta.pop());
                    wnWellStatus.setLevelName6(parNameSta.pop());
                }
                list.add(wnWellStatus);
            }
        } while (count == pageSize);
        wnWellStatusService.saveAndUpdate(list);
        List<WnWellInfo> wellInfoList = new ArrayList<>();
        curPage = 1;
        do {
            String s = baseDataClient.getWellInfo(curPage++, pageSize);
            System.out.println(s);
            if (true) return;
            Result res = JSONObject.parseObject(s, Result.class);
            JSONArray jsonArray = JSONObject.parseArray(res.getData().toString());
            count = jsonArray.size();
            for (int i = 0; i < jsonArray.size(); i++) {
                JSONObject jao = jsonArray.getJSONObject(i);
                WnWellInfo wellInfo = new WnWellInfo();
                wellInfo.setWellId(jao.getString("wellId"));
                wellInfo.setOrgId(jao.getInteger("orgId"));
                String spudDate = jao.getString("spudDate");

                if (spudDate == null) continue;
                wellInfo.setSpudDate(LocalDateTime.parse(spudDate, DateTimeFormatter.ofPattern("yyyy-MM-dd HH:mm:ss")));
                Integer id = wellInfo.getOrgId();
                Stack<Integer> parIdSta = new Stack<>();
                Stack<String> parNameSta = new Stack<>();
                Integer level = -1;
                do {
                    parIdSta.push(id);
                    String org = baseDataClient.getOrgById(id.toString());
                    res = JSONObject.parseObject(org, Result.class);
                    JSONObject jo = JSONObject.parseObject(res.getData().toString());
                    id = Integer.parseInt(jo.getString("parentId"));
                    level = jo.getInteger("orgLevel");
                    parNameSta.push(jo.getString("orgName"));
                } while (level != 1);
                //一般最多只有五级，如果需要增加则增加数据库字段数量
                if (!parIdSta.isEmpty()) {
                    wellInfo.setLevel1(parIdSta.pop());
                    wellInfo.setLevelName1(parNameSta.pop());
                }
                if (!parIdSta.isEmpty()) {
                    wellInfo.setLevel2(parIdSta.pop());
                    wellInfo.setLevelName2(parNameSta.pop());
                }
                if (!parIdSta.isEmpty()) {
                    wellInfo.setLevel3(parIdSta.pop());
                    wellInfo.setLevelName3(parNameSta.pop());
                }
                if (!parIdSta.isEmpty()) {
                    wellInfo.setLevel4(parIdSta.pop());
                    wellInfo.setLevelName4(parNameSta.pop());
                }
                if (!parIdSta.isEmpty()) {
                    wellInfo.setLevel5(parIdSta.pop());
                    wellInfo.setLevelName5(parNameSta.pop());
                }
                if (!parIdSta.isEmpty()) {
                    wellInfo.setLevel6(parIdSta.pop());
                    wellInfo.setLevelName6(parNameSta.pop());
                }
                wellInfoList.add(wellInfo);
            }
        } while (count == pageSize);
        try {
            System.out.println(wellInfoList.size());
            wnWellInfoService.saveOrUpdateBatch(wellInfoList);
        } catch (Exception e) {
            e.printStackTrace();
        }
    }
}
