package com.gct.warning.mybatisplus;

import com.alibaba.fastjson.JSONArray;
import com.baomidou.mybatisplus.annotation.DbType;
import com.baomidou.mybatisplus.annotation.FieldFill;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.generator.AutoGenerator;
import com.baomidou.mybatisplus.generator.config.DataSourceConfig;
import com.baomidou.mybatisplus.generator.config.GlobalConfig;
import com.baomidou.mybatisplus.generator.config.PackageConfig;
import com.baomidou.mybatisplus.generator.config.StrategyConfig;
import com.baomidou.mybatisplus.generator.config.po.TableFill;
import com.baomidou.mybatisplus.generator.config.rules.DateType;
import com.baomidou.mybatisplus.generator.config.rules.NamingStrategy;
import com.gct.warning.WarningApplication;
import com.gct.warning.entity.WnGkMsg;
import com.gct.warning.service.WnGkMsgService;
import com.gct.warning.service.WnWellStatusService;
import com.gct.warning.service.impl.MainServiceImpl;
import com.gct.warning.service.impl.WarningTaskServiceImpl;
import org.junit.Test;
import org.junit.runner.RunWith;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.test.context.SpringBootTest;
import org.springframework.test.context.ContextConfiguration;
import org.springframework.test.context.junit4.SpringRunner;

import java.util.ArrayList;
import java.util.Collection;
import java.util.HashMap;
import java.util.List;

@SpringBootTest(classes = WarningApplication.class)
@RunWith(SpringRunner.class)
@ContextConfiguration
public class MyBatisPlusGeneratorTest {

    public static void main(String[] args) {
        // 代码生成器
        AutoGenerator mpg = new AutoGenerator();

        // 全局配置
        GlobalConfig gc = new GlobalConfig();
        //当前路径
        String projectPath = System.getProperty("user.dir");
        //输出路径
        //gc.setOutputDir(projectPath + "/src/main/java");
        gc.setOutputDir("/home/xsr/");
        gc.setAuthor("xsr");    //设置作者
        gc.setFileOverride(true);//是否覆盖
        gc.setActiveRecord(true);
        gc.setEnableCache(false);// XML 二级缓存
        gc.setBaseResultMap(true);// XML ResultMap
        gc.setBaseColumnList(false);// XML columList
        //生成代码后，是否打开文件夹
        gc.setOpen(false);
        gc.setFileOverride(true);  //是否覆盖原来代码，个人建议设置为false,别覆盖，危险系数太高
        gc.setServiceName("%sService");   //去掉service的I前缀,一般只需要设置service就行
/*        gc.setMapperName("%sMapper");
        gc.setXmlName("%sMapper");
        gc.setServiceImplName("%sServiceImpl");
        gc.setControllerName("%sController");*/

        gc.setDateType(DateType.TIME_PACK);   //日期格式
        gc.setSwagger2(true);       // 实体属性 Swagger2 注解,实体类上会增加注释
        mpg.setGlobalConfig(gc);

        // 数据源配置
        DataSourceConfig dsc = new DataSourceConfig();
        dsc.setUrl("jdbc:postgresql://101.200.219.190:54321/warning");
        // dsc.setSchemaName("public");
        dsc.setDriverName("org.postgresql.Driver");
        dsc.setUsername("root");
        dsc.setPassword("123456");
        dsc.setDbType(DbType.POSTGRE_SQL);    //指定数据库的类型
        mpg.setDataSource(dsc);

        // 包配置
        PackageConfig pc = new PackageConfig();
        pc.setParent("com.gct.warning");   //自定义包的路径
        //pc.setModuleName("module");   //模块名称  设置后,会生成com.cxyxs.test.module,里面存放之前设置的mapper,entity
        pc.setEntity("entity");
        pc.setMapper("mapper");
        pc.setService("service");
        pc.setController("controller");
        mpg.setPackageInfo(pc);

        // 策略配置
        StrategyConfig strategy = new StrategyConfig();
        strategy.setInclude("wn_gk_msg");    //设置映射的表名，可以设置多个表

        //表前缀设置  cxyxs_student
        //strategy.setTablePrefix(new String[]{"cxyxs_"});
        //包的命名规则，使用驼峰规则
        strategy.setNaming(NamingStrategy.underline_to_camel);
        //列的名称，使用驼峰规则
        strategy.setColumnNaming(NamingStrategy.underline_to_camel);
        //是否使用lombok
        strategy.setEntityLombokModel(true);
        //驼峰命名
        strategy.setRestControllerStyle(true);
        strategy.setLogicDeleteFieldName("is_delete");   //逻辑删除,假删除会用到

        //自动填充字段,在项目开发过程中,例如创建时间，修改时间,每次，都需要我们来指定，太麻烦了,设置为自动填充规则，就不需要我们赋值咯
        TableFill fillInsert = new TableFill("create_time", FieldFill.INSERT);
        TableFill fillUpdate = new TableFill("update_time", FieldFill.UPDATE);
        List fillLists = new ArrayList();
        fillLists.add(fillInsert);
        fillLists.add(fillUpdate);
        strategy.setTableFillList(fillLists);
        //乐观锁
        //strategy.setVersionFieldName("version");
        mpg.setStrategy(strategy);
        mpg.execute();  //执行
    }

    @Autowired
    WarningTaskServiceImpl warningTaskService;

    @Autowired
    WnWellStatusService wnWellStatusService;

    @Autowired
    MainServiceImpl mainService;

    @Test
    public void test() throws InterruptedException {

        try {
            warningTaskService.task2();
        }catch (Exception e){
            e.printStackTrace();
        }

    }

    @Test
    public void test2() {
        //System.out.println(wnWellStatusService.getWellDataCount("2021-01-21", 3, 5,2,3));
    }

    @Test
    public void test3() {
        boolean isdeal = false;
        String category = "问题";
        List<String>rank = new ArrayList<>();
        rank.add("1");rank.add("2");rank.add("3");
        System.out.println(mainService.getProblemListItems(isdeal, category, rank, 3, "[\"1\",\"泵卡\"]", "2021-05-13 00:00:00", "2022-12-31 00:00:00"));
    }


    @Test
    public void test4(){
        System.out.println(mainService.getStatisticalAnalysis("2021-06-02", "2021-06-03", 1, 0));
    }


    @Autowired
    WnGkMsgService wnGkMsgService;

    @Test
    public void test5(){
        List<WnGkMsg> list = wnGkMsgService.list();
        HashMap<String,WnGkMsg>map = new HashMap<>();
        list.forEach(x->{
            map.put(x.getResultId(),x);
        });
        Collection<WnGkMsg> values = map.values();
        wnGkMsgService.remove(new QueryWrapper<WnGkMsg>().isNotNull("well_id"));
        wnGkMsgService.saveBatch(values);
    }
}